

/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <julianacamilo_@hotmail.com> and <thiagums@hotmail.com> wrote this file.
 * As long as you retain this notice you can do whatever you want with this stuff.
 * If we meet some day, and you think this stuff is worth it, you can buy
 * me a beer in return Juliana Camilo Inácio e Thiago Martins de Sousa
 * ----------------------------------------------------------------------------
 */

/*
 * Tradução da Licensa
 *  ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <julianacamilo_@hotmail.com> e <thiagums@hotmail.com>  escreveram esse código.
 * Enquanto você possui-lo, note que  você pode fazer o que desejar com ele. Se um
 * dia a gente se conhecer, e você achar que isso funciona, você pode nos comprar
 * uma cerveja em homenagem a Juliana Camilo Inácio e Thiago Martins de Sousa
 * ----------------------------------------------------------------------------
 */



package pintorj2d;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.geom.Ellipse2D;


/**
 * Classe Elipse é filha da classe FormaGeometrica
 *
 */

public class Elipse extends FormaGeometrica {

    /**
     * Construtor utilizado para desenhar a elipse
     *
     * @param x
     * @param y
     * @param altura
     * @param largura
     * @param c
     */

    public Elipse(int x, int y, int altura, int largura, Color c) {
        super(x, y, altura, largura, c);
    }

    /**
     * Construtor utilizado para a leitura de um arquivo texto que contenha elipse
     *
     * @param x
     * @param y
     * @param altura
     * @param largura
     * @param c
     * @param f
     */

    public Elipse(int x, int y, int altura, int largura, Color c, Color f) {
        super(x, y, altura, largura, c, f);
    }

/**
 * Implementação do método desenhar recebendo Graphics2D da classe Area
 *
 * @param g
 */
    @Override
    public void desenhar(Graphics2D g) {
        if (corDeFundo == null) {
            g.setColor(corDaLinha);
            g.drawOval(x, y, largura, altura);
        } else {
            g.setColor(Color.RED);
            g.setPaint(corDeFundo);
            g.fillOval(x, y, largura, altura);

        }
    }

    /**
     * Implementação do método intersecção
     *
     * @param posx
     * @param posy
     * @return true se o clique do mouse estiver em uma intersecção com a Elipse
     */

    @Override
    public boolean interseccao(int posx, int posy) {
        Ellipse2D aux = new Ellipse2D.Double(x, y, largura, altura);
        if (aux.contains(posx, posy)) {
            return true;
        }
        return false;
    }
}
