

/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <julianacamilo_@hotmail.com> and <thiagums@hotmail.com> wrote this file.
 * As long as you retain this notice you can do whatever you want with this stuff.
 * If we meet some day, and you think this stuff is worth it, you can buy
 * me a beer in return Juliana Camilo Inácio e Thiago Martins de Sousa
 * ----------------------------------------------------------------------------
 */

/*
 * Tradução da Licensa
 *  ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <julianacamilo_@hotmail.com> e <thiagums@hotmail.com>  escreveram esse código.
 * Enquanto você possui-lo, note que  você pode fazer o que desejar com ele. Se um
 * dia a gente se conhecer, e você achar que isso funciona, você pode nos comprar
 * uma cerveja em homenagem a Juliana Camilo Inácio e Thiago Martins de Sousa
 * ----------------------------------------------------------------------------
 */


package pintorj2d;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;

public abstract class FormaGeometrica {
//Coordenada x da forma geométrica

    protected int x;
//Coordenada y da forma geométrica
    protected int y;
//Altura da forma geométrica
    protected int altura;
//Largura da forma geométrica
    protected int largura;
//Cor da linha da imagem
    protected Color corDaLinha;
//Cor do fundo
    protected Color corDeFundo;
//Objeto do tipo Graphics2D que irá fazer o "desenho" das imagens
    protected Graphics2D g2d;
/**
 * Construtor usado para desenhar na tela, quando algum botao de forma for pressionado
 * @param x
 * @param y
 * @param altura
 * @param largura
 * @param cor
 */
    public FormaGeometrica(int x, int y, int altura, int largura, Color cor) {
        this.x = x;
        this.y = y;
        this.altura = altura;
        this.largura = largura;
        this.corDaLinha = cor;
        this.corDeFundo = null;

    }

    /**
     * Construtor usado quando é lido o arquivo de texto salvo
     *
     * @param x
     * @param y
     * @param altura
     * @param largura
     * @param cor
     * @param corFundo
     */

    public FormaGeometrica(int x, int y, int altura, int largura, Color cor, Color corFundo) {
        this.x = x;
        this.y = y;
        this.altura = altura;
        this.largura = largura;
        this.corDaLinha = cor;
        this.corDeFundo = corFundo;

    }

    /**
     * Altera o valor da coordenada X
     *
     * @param x
     */

    public void setX(int x) {
        this.x = x;
    }
/**
 * Altera o valor da coordenada Y
 *
 * @param y
 */

    public void setY(int y) {
        this.y = y;
    }

    /**
     * Altera o valor da altura
     *
     * @param altura
     */

    public void setAltura(int altura) {
        this.altura = altura;
    }

    /**
     * Altera o valor da largura
     *
     * @param largura
     */

    public void setlargura(int largura) {
        this.largura = largura;
    }

    /**
     * Altera o valor de cor de fundo
     *
     * @param corF
     */

    public void setCorDeFundo(Color corF){
        this.corDeFundo = corF;
    }

    /**
     * Método abstrato desenhar implementado em cada tipo de forma geométrica
     *
     * @param g2d
     */

    public abstract void desenhar(Graphics2D g2d);

    /**
     * Método abstrato para verificar se a clic do mouse está dentro de uma intersecção de uma figura
     *
     * @param posx
     * @param posy
     * @return
     */

    public abstract boolean interseccao(int posx, int posy);
}


