

/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <julianacamilo_@hotmail.com> and <thiagums@hotmail.com> wrote this file.
 * As long as you retain this notice you can do whatever you want with this stuff.
 * If we meet some day, and you think this stuff is worth it, you can buy
 * me a beer in return Juliana Camilo Inácio e Thiago Martins de Sousa
 * ----------------------------------------------------------------------------
 */

/*
 * Tradução da Licensa
 *  ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <julianacamilo_@hotmail.com> e <thiagums@hotmail.com>  escreveram esse código.
 * Enquanto você possui-lo, note que  você pode fazer o que desejar com ele. Se um
 * dia a gente se conhecer, e você achar que isso funciona, você pode nos comprar
 * uma cerveja em homenagem a Juliana Camilo Inácio e Thiago Martins de Sousa
 * ----------------------------------------------------------------------------
 */

package pintorj2d;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.geom.Line2D;


/**
 *
 * Classe Linha é filha de Formageométrica
 */

public class Linha extends FormaGeometrica {

    /**
     *Construtor utilizado quando a Linha é desenhada e para leitura de um arquivo texto que contenha uma linha
     *
     * @param x1
     * @param y1
     * @param x2
     * @param y2
     * @param cor
     */

    public Linha(int x1, int y1, int x2, int y2, Color cor) {
        super(x1, y1, x2, y2, cor);
    }

/**
 * Implementação do método desenhar recebendo Graphics2D da classe Area
 * 
 * @param g
 */
    @Override
    public void desenhar(Graphics2D g) {
        g.setColor(corDaLinha);
        g.drawLine(x, y, largura, altura);
        //Largura será o x2 e altura y2
    }
/**
 * Implementação do método intersecção
 *
 * @param posx
 * @param posy
 * @return true se o clique do mouse estiver em uma intersecção com a Linha
 */
    @Override
    public boolean interseccao(int posx, int posy) {
        Line2D aux = new Line2D.Double(x, y, largura, altura);
        if (aux.intersectsLine(posx, posy, posx, posy)) {
            return true;
        }
        return false;
    }
}
