
/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <julianacamilo_@hotmail.com> and <thiagums@hotmail.com> wrote this file.
 * As long as you retain this notice you can do whatever you want with this stuff.
 * If we meet some day, and you think this stuff is worth it, you can buy
 * me a beer in return Juliana Camilo Inácio e Thiago Martins de Sousa
 * ----------------------------------------------------------------------------
 */

/*
 * Tradução da Licensa
 *  ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <julianacamilo_@hotmail.com> e <thiagums@hotmail.com>  escreveram esse código.
 * Enquanto você possui-lo, note que  você pode fazer o que desejar com ele. Se um
 * dia a gente se conhecer, e você achar que isso funciona, você pode nos comprar
 * uma cerveja em homenagem a Juliana Camilo Inácio e Thiago Martins de Sousa
 * ----------------------------------------------------------------------------
 */

package pintorj2d;

import java.awt.Color;
import java.awt.Graphics2D;

import java.awt.geom.RoundRectangle2D;

/**
 *
 * Classe RetanguloArredondado é filha de FormaGeometrica
 */

public class RetanguloArredondado extends FormaGeometrica {

    /**
     * Construtor utilizado quando o RetanguloArredondado é desenhado na tela de Area
     *
     * @param x
     * @param y
     * @param altura
     * @param largura
     * @param c
     */

    public RetanguloArredondado(int x, int y, int altura, int largura, Color c) {
        super(x, y, altura, largura, c);
    }

    /**
     * Construtor utilizado para leitura do arquivo texto que contenha um retangulo arredondado
     *
     * @param x
     * @param y
     * @param altura
     * @param largura
     * @param c
     * @param f
     */

    public RetanguloArredondado(int x, int y, int altura, int largura, Color c, Color f) {
        super(x, y, altura, largura, c, f);
    }

/**
 * Implementação do método desenhar recebendo Graphics2D da classe Area
 *
 * @param g
 */

    @Override
    public void desenhar(Graphics2D g) {
        if (corDeFundo == null) {
            g.setColor(corDaLinha);
            g.drawRoundRect(x, y, largura, altura, 30, 30);
        } else {
            g.setColor(corDeFundo);
            g.fillRoundRect(x, y, largura, altura, 30, 30);
        }
    }

    /**
     * Implementação do método intersecção
     *
     * @param posx
     * @param posy
     * @return true se o clique do mouse estiver em uma intersecção com o RetanguloArredondado
     */

    public boolean interseccao(int posx, int posy) {
        RoundRectangle2D aux = new RoundRectangle2D.Double();
        aux.setRoundRect(x, y, largura, altura, 30, 30);
        if (aux.contains(posx, posy)) {
            return true;
        }
        return false;
    }
}
